package br.usp.ime.evolvinggraph;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.util.List;

import org.junit.Test;

import br.usp.ime.algorithms.Algorithm;
import br.usp.ime.algorithms.ForemostAlgorithm;

public class TestEvolvingGraph {

	@Test
	public void testGetEdge() {
		EvolvingGraph eg = new EvolvingGraph (3);
		eg.createEdge(0, 1, new Schedule(), 0);
		eg.createEdge(0, 2, new Schedule(), 0);
		eg.createEdge(1, 0, new Schedule(), 0);
		eg.createEdge(2, 0, new Schedule(), 0);
		eg.createEdge(1, 2, new Schedule(), 0);
		eg.createEdge(2, 1, new Schedule(), 0);
		Edge e = eg.getEdge(1, 0);
		
		assertEquals(1, e.getU().getId());
		assertEquals(0, e.getV().getId());
	}
	
	@Test
	public void testRemoveJourney () {
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraphFromONE("input/testeONE1.in", 6, 20);
		Algorithm alg = new ForemostAlgorithm();
		List<Journey> journeys = alg.calculate(eg, eg.getNode(0));
		Journey before = journeys.get(5);

		eg.removeJourney(before);
		journeys = alg.calculate(eg, eg.getNode(0));
		assertTrue(before.getArrivalDate() != journeys.get(5).getArrivalDate());
	}
	
	@Test
	public void testInputRead1 () {
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraphFromONE("input/testeONE1.in", 6, 20);
		assertEquals(6, eg.getNumOfNodes());
		assertEquals(10, eg.getNumOfEdges());
	}
	
	@Test
	public void testInputRead2 () {
		EvolvingGraph eg = EvolvingGraph.readEvolvingGraphFromONE("input/testeONE2.in", 126, 20000);
		assertEquals(126, eg.getNumOfNodes());
		
	}

}
